#include <u.h>
#include <libc.h>
#include <mswin.h>

int	readgid(char*);
int	uflag;

void
main(int argc, char *argv[])
{
	int i;
	Dir dir;
	char *group;
	char *errs;

	ARGBEGIN {
	default:
	usage:
		fprint(2, "usage: chgrp [ -uo ] group file ....\n");
		exits("usage");
		return;
	case 'u':
	case 'o':
		uflag++;
		break;
	} ARGEND
	if(argc < 1)
		goto usage;

	if(_takepriv(SE_TAKE_OWNERSHIP_NAME) == -1)
		fprint(2, "%s: cannot gain take ownership priviledge - %r\n", argv0);
	if(_takepriv(SE_RESTORE_NAME) == -1)
		fprint(2, "%s: cannot gain restore priviledge - %r\n", argv0);
	if(_takepriv(SE_BACKUP_NAME) == -1)
		fprint(2, "%s: cannot gain backup priviledge - %r\n", argv0);
	if(_takepriv(SE_CHANGE_NOTIFY_NAME) == -1)
		fprint(2, "%s: cannot gain change notify priviledge - %r\n", argv0);

	group = argv[0];
	errs = 0;
	for(i=1; i<argc; i++){
		nulldir(&dir);
		if(uflag)
			dir.uid = group;
		else
			dir.gid = group;
		if(dirwstat(argv[i], &dir) == -1) {
			fprint(2, "chgrp: can't wstat %s: %r\n", argv[i]);
			errs = "can't wstat";
			continue;
		}
	}
	exits(errs);
}
