/* auth */
Chan *doauth(Chan *ch, char *method, char *param, char * user, int nuser, HANDLE *putok);

/* chan */
Chan *mkchan(void);
Chan *getchan(Chan *ch);
int readchan(Chan *ch, void *data, int len, vlong off);
int writechan(Chan *ch, void *data, int len, vlong off);
void closechan(Chan *ch);
void freechan(Chan *ch);
Chan *mkiochan(Chan *cin, Chan *cout);
int vchanprint(Chan *ch, char *fmt, va_list a);


/* sock */
void initsock(void);
void tcpserver(int port, void (*client)(void *));

/* file */
Chan* mkfilechan(HANDLE h);
int mkpipechan(Chan *ch[2]);
Chan* mkstdchan(int what);
HANDLE *pfilehandle(Chan *ch);

/* tls */
void inittls(void);
Chan *tlsserver(Chan *slave, char *cert);

/* mnt */
Mnt *mkmount(Chan *ch);
void freemount(Mnt *m);
void mntversion(Mnt *m, char *version, ulong msize);
Chan *mntattach(Mnt *m, char *uname, char *spec);
Chan *mntwalk(Chan *c, char **name, int nname);
Chan *mntopen(Chan *c, int omode);
void mntremove(Chan *c);

/* shell */
void shell(Chan *cin, Chan *cout, Chan *cerr, Chan *cnote, char *cmd, char *user, HANDLE utok);

/* main */
void threadmain(int argc, char *argv[]);
void setconfstr(char *key, char *str);
char *getconfstr(char *key, char *buf, int nbuf);
void writestr(Chan *ch, char *str, char *thing, int ignore);
int readstr(Chan *ch, char *str, int len);

/* syslog */
void syslog(int cons, char *logname, char *fmt, ...);



/* libc.c */
void __abort(void);
int return0(void *arg);
Errjmp *pusherror(void);
Errjmp *poperror(void);
void error(char *fmt, ...);

#define waserror()	setjmp(pusherror()->jmp)
#define nexterror()	longjmp(poperror()->jmp, 1)

