#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "dat.h"
#include "fns.h"


int debug;

void
writestr(Chan *ch, char *str, char *thing, int ignore)
{
	if(waserror()){
		if(ignore)
			return;
		nexterror();
	}
	writechan(ch, str, strlen(str)+1, ch->off);
	poperror();
}

int
readstr(Chan *ch, char *str, int len)
{
	int n;

	while(len) {
		n = readchan(ch, str, 1, ch->off);
		if(n < 0) 
			return -1;
		if(*str == 0)
			return 0;
		str++;
		len--;
	}
	return -1;
}

static void
client(void *aux)
{
	char buf[MaxStr], xdir[MaxStr], cmd[MaxStr], user[MaxStr], *s, *name[8];
	HANDLE utok;
	Chan *ch, *cons, *root, *note;
	Mnt *m;

	m = nil;
	ch = aux;
	if(waserror()){
		syslog(1, PROGNAME, "client: %s", errorstr());
		freechan(ch);
		freemount(m);
		nexterror();
	}
	if(readstr(ch, cmd, sizeof(cmd)) < 0)
		error("readstr authmethod");
	if(s = strchr(cmd, ' '))
		*s++ = 0;
	utok = 0;
	ch = doauth(ch, cmd, s, user, sizeof(user), &utok);
	if(waserror()){
		CloseHandle(utok);
		nexterror();
	}
	syslog(1, PROGNAME, "client: auth ok user=%s token=%x", user, utok);

	cmd[0] = 0;
	if(readstr(ch, xdir, sizeof(xdir)) < 0)
		error("readstr dir/cmd");
	if(xdir[0] == '!') {
		for(s = &xdir[1]; *s==' '; s++)
				;
		strncpy(cmd, s, sizeof(cmd));
		if(readstr(ch, xdir, sizeof(xdir)) < 0)
			error("readstr dir");
	} else {
		strncpy(cmd, "cmd.exe", sizeof(cmd));
	}

	writestr(ch, "FS", "FS", 0);
	writestr(ch, "/", "exportfs dir", 0);
	if(readchan(ch, buf, sizeof(buf), 0) != 2 || buf[0] != 'O' || buf[1] != 'K')
		error("remote tree");

	m = mkmount(ch); ch = nil;
	root = mntattach(m, user, nil);
	if(waserror()){
		freechan(root);
		nexterror();
	}

	note = nil;
	name[0] = "dev";
	name[1] = "cons";
	cons = mntwalk(root, name, 2);
	if(waserror()){
		freechan(note);
		freechan(cons);
		nexterror();
	}
	mntopen(cons, 2);
	if(waserror()){
		freechan(note);
		note = nil;
	} else {
		name[0] = "dev";
		name[1] = "cpunote";
		note = mntwalk(root, name, 2);
		mntopen(note, 0);
		poperror();
	}

	syslog(1, PROGNAME, "client: shell %s", cmd);
	if(waserror()){
		if(!waserror()){
			chanprint(cons, PROGNAME ": %s\n", errorstr());
			poperror();
		}
		nexterror();
	}
	shell(cons, cons, cons, note, cmd, user, utok);
	poperror();
	syslog(1, PROGNAME, "client: shell %s terminated", cmd);

	poperror();
	freechan(note);
	freechan(cons);

	poperror();
	freechan(root);

	poperror();
	CloseHandle(utok);

	poperror();
	freemount(m);
}

static void
server(void *aux)
{
	if(waserror()){
		syslog(1, PROGNAME, "server: %s", errorstr());
	}
	else{
		inittls();
		initsock();
		tcpserver(17010, client);
		poperror();
	}
	syslog(1, PROGNAME, "shutting down");
	SetEvent(hsvcshutdown);
}


void
usage(void)
{
	chanprint(mkstdchan(2), "usage: %s [ -c tlscertsubject ] [ -i | -u ]\n", argv0);
	exit(1);
}

void 
threadmain(int argc, char *argv[])
{
	if(waserror()){
		syslog(1, PROGNAME, "error: %s", errorstr());
		nexterror();
	}
	threadcreate(server, nil);
	poperror();
}
