#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "ninep.h"

char *argv0 = "?";

int
errstr(unsigned long e, char *s, int l)
{
	int n;
	char *p, prov[16];

	n = 0;
	if(e == ERROR_EXTENDED_ERROR){
		e = WNetGetLastError(&e, s+n, l-n, prov, sizeof(prov));
		if((p = strpbrk(s+n, ".\n\r")) != NULL)
			*p = 0;
		n = strlen(s);
		n += snprintf(s+n, l-n, "(%s)", prov);
	}
	else{
		n += snprintf(s+n, l-n, " - ");
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,
			e, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			s+n, l-n, 0);
		if((p = strpbrk(s+n, ".\n\r")) != NULL)
			*p = 0;
		n = strlen(s);
	}
	return n;
}

void
sysfatal(char *fmt, ...)
{
	unsigned long e;
	va_list args;
	char s[1024];

	*s = 0;
	fprintf(stderr, "%s: ", argv0);
	va_start(args, fmt);
	vfprintf(stderr, fmt, args);
	va_end(args);
	if((e = GetLastError()) != 0)
		errstr(e, s, sizeof(s));
	SetLastError(0);
	fprintf(stderr, "%s\n", s);
	fflush(stderr);
	Sleep(100);
	exit(1);
}


void
syswarn(char *fmt, ...)
{
	int e;
	va_list args;
	char s[1024];

	*s = 0;
	fprintf(stderr, "%s: ", argv0);
	va_start(args, fmt);
	vfprintf(stderr, fmt, args);
	va_end(args);
	if((e = GetLastError()) != 0)
		errstr(e, s, sizeof(s));
	SetLastError(0);
	fprintf(stderr, "%s\n", s);
	fflush(stderr);
	Sleep(500);
	SetLastError(0);
}

void
syslog(char *fmt, ...)
{
	int e;
	FILE *fp;
	time_t now;
	va_list args;
	char *p, *tstr, s[1024];

	*s = 0;
	if((e = GetLastError()) != 0)
		errstr(e, s, sizeof(s));
	SetLastError(0);

	if((fp = fopen("c:/temp/cpud.log", "a")) == NULL)
		return;
	time(&now);
	tstr = ctime(&now);
	if ((p = strpbrk(tstr, "\n\r")) != NULL)
		*p = 0;
	fprintf(fp, "%s: ", tstr);


	va_start(args, fmt);
	vfprintf(fp, fmt, args);
	va_end(args);

	fprintf(fp, "%s\n", s);
	fflush(fp);
	fclose(fp);
	SetLastError(0);
}
