#include <u.h>
#include <libc.h>
#include <bio.h>
#include <ctype.h>
#include <mswin.h>


int
isdir(char *s)
{
	int a;
	char *e;
	wchar_t *w;

	for(; isspace(*s); s++)
		continue;
	for(e = strchr(s, 0) -1; *e == '/' || *e == '\\' || isspace(*e); e--)
		*e = 0;

	w = _winpath(s);
	a = GetFileAttributes(w);
	free(w);

	if(a != INVALID_FILE_ATTRIBUTES && 
	  (a & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
		return 1;
	return 0;
}

void
usage(void)
{
	fprint(2, "usage: %s [-1] path...\n", argv0);
	exits("usage");
}
	
void
main(int argc, char *argv[])
{
	Biobuf out;
	int i, one, debug;

	one = 0;
	debug = 0;
	ARGBEGIN{
	case 'd':
		debug++;
		break;
	case '1':
		one++;
		break;
	default:
		usage();
		break;
	}ARGEND;

	quotefmtinstall();
	Binit(&out, 1, OWRITE);
	for(i = 0; i < argc; i++){
		if(debug)
			fprint(2, "isdir %q\n", argv[i]);
		if(isdir(argv[i])){
			Bprint(&out, "%q\n", argv[i]);
			if(one)
				break;
		}
	}
	Bprint(&out, "\n");
	exits(nil);
}
