/* contents of /dev/cputype on plan9 */
#include <u.h>
#include <libc.h>
#include <mswin.h>

#ifndef PROCESSOR_AMD_X8664
#define PROCESSOR_AMD_X8664 8664
#endif

static ulong
cpumhz(void)
{
	HKEY hk;
	ulong mhz, sz;

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,
		L"HARDWARE\\DESCRIPTION\\System\\CentralProcessor\\0",
		0, KEY_READ, &hk) != 0)
		return -1;
	sz = sizeof(mhz);
	if(RegQueryValueEx(hk, L"~MHz", NULL, NULL, (void *)&mhz, &sz) != 0)
		return -1;
	return mhz;
}

static char *
cputype(void)
{
	SYSTEM_INFO si;

	GetNativeSystemInfo(&si);
	switch(si.dwProcessorType){
	case PROCESSOR_INTEL_386:
		return "i386";
		break;
	case PROCESSOR_INTEL_486:
		return "i486";
		break;
	case PROCESSOR_INTEL_PENTIUM:
		return "i586";
		break;
	case PROCESSOR_AMD_X8664:
		return "amd64";
		break;
	default:
		return "unknown";
		break;
	}
}


void
main(int argc, char *argv[])
{
	print("%s %d\n", cputype(), cpumhz());
	exits(nil);
}

