#include <stdio.h>
#include <windows.h>
#include <userenv.h>
#include "dosd.h"

/* set up some basic, plan9 style environment variables */
void 
initenv(char *user, char *home)
{
	SetEnvironmentVariable("service", "cpu");
	SetEnvironmentVariable("home", home);
	SetEnvironmentVariable("user", user);
}

/* load user's Windows Profile (registry hive) */
HANDLE
loadprofile(HANDLE token, char *user, char *prof)
{
	PROFILEINFO pri;

	memset(&pri, 0, sizeof(pri));
	pri.dwSize = sizeof(pri);
	pri.lpUserName = user;
	pri.lpProfilePath = prof;
	if(LoadUserProfile(token, &pri) == 0)
		syswarn("%s %s - cannot load profile", user, prof);
	return pri.hProfile;
}
		
void
unloadprofile(HANDLE token, HANDLE prof)
{
	UnloadUserProfile(token, prof);
}
