#include <stdio.h>
#include <windows.h>
#include "dosd.h"

char *Logfile;

static int
errstr(char *s, int l)
{
	int n;
	unsigned long e;
	char *p, prov[16];

	n = 0;
	if((e = GetLastError()) != 0){
		if(e == ERROR_EXTENDED_ERROR){
			e = WNetGetLastError(&e, s+n, l-n, prov, sizeof(prov));
			if((p = strpbrk(s+n, ".\n\r")) != NULL)
				*p = 0;
			n = strlen(s);
			n += snprintf(s+n, l-n, "(%s)", prov);
		}
		else{
			n += snprintf(s+n, l-n, " - ");
			FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,
				e, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
				s+n, l-n, 0);
			if((p = strpbrk(s+n, ".\n\r")) != NULL)
				*p = 0;
			n = strlen(s);
		}
	}
	return n;
}

void
logmsg(char *fmt, ...)
{
	FILE *fp;
	va_list args;

	if(Logfile && GetFileAttributes(Logfile) == INVALID_FILE_ATTRIBUTES)
		return;

	va_start(args, fmt);
	if((fp = fopen(Logfile, "a+")) == NULL)
		return;
	vfprintf(fp, fmt, args);
	va_end(args);

	fclose(fp);
}

void
sysfatal(char *fmt, ...)
{
	int n, l;
	va_list args;
	char s[1024];
	unsigned long x;

	n = 0;
	l = sizeof(s);
	n += snprintf(s, l, "%s: ", argv0);

	va_start(args, fmt);
	n += vsnprintf(s+n, l-n, fmt, args);
	va_end(args);

	n += errstr(s+n, l-n);
	n += snprintf(s+n, l-n, "\n");

	logmsg("%s", s);
 	WriteFile(GetStdHandle(STD_ERROR_HANDLE), s, n, &x, NULL);
	Sleep(100);
	exit(1);
}

void
syswarn(char *fmt, ...)
{
	int n, l;
	va_list args;
	char s[1024];
	unsigned long x;

	n = 0;
	l = sizeof(s);
	n += snprintf(s, l, "%s: ", argv0);

	va_start(args, fmt);
	n += vsnprintf(s+n, l-n, fmt, args);
	va_end(args);

	n += errstr(s+n, l-n);
	n += snprintf(s+n, l-n, "\n");

 	logmsg("%s", s);
	WriteFile(GetStdHandle(STD_ERROR_HANDLE), s, n, &x, NULL);
}

