#include <u.h>
#include <libc.h>
#include <mswin.h>

typedef struct Regent Regent;
struct Regent {
	wchar_t *path;
	wchar_t *name;
};

Regent Regentry[] = {
	{ L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Group Policy\\History", L"MachineDomain" },	// if AD in operation 
	{ L"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters", L"Domain" },						// DNS domain
	{ L"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon", L"DefaultDomainName" },			// old machines
	{ nil, nil }
};

int
lookreg(wchar_t *nam, int len, Regent *re)
{
	HKEY hk;
	DWORD sz;

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, re->path, 0, KEY_READ, &hk) != 0)
		return -1;
	sz = len;
	if(RegQueryValueEx(hk, re->name, NULL, NULL, (void *)nam, &sz) != 0)
		return -1;
	return 0;
}

void
main(void)
{
	int i;
	wchar_t nam[1024];

	_widefmtinstall();
	for(i = 0; Regentry[i].name; i++){
		*nam = 0;
		if(lookreg(nam, nelem(nam), &Regentry[i]) == 0 && *nam){
			print("%w\n", nam);
			break;
		}
	}
	exits(nil);
}

