#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <wtsapi32.h>
#include <wtsapi32-missing.h>

int
ciwcscmp(wchar_t *s1, wchar_t *s2)
{
	Rune c1, c2;

	for(;;) {
		c1 = *s1++;
		if(isupperrune(c1))
			c1 = tolowerrune(c1);
		c2 = *s2++;
		if(isupperrune(c2))
			c1 = tolowerrune(c2);
		if(c1 != c2) {
			if(c1 > c2)
				return 1;
			return -1;
		}
		if(c1 == 0)
			return 0;
	}
}

void
main(void)
{
	int i, cons;
	SID_NAME_USE type;
	WTS_PROCESS_INFO *wp;
	wchar_t usr[128], dom[128];
	DWORD num, usrsz, domsz;

	_widefmtinstall();
	if(WTSEnumerateProcesses(0, 0, 1, &wp, &num) == 0)
		sysfatal("WTSEnumerateProcesses failed, %r");

	cons = -1;
	for(i = 0; i < num; i++)
		if(ciwcscmp(wp[i].pProcessName, L"winlogon.exe") == 0){
			cons = wp[i].SessionId;
			break;
		}
	for(i = 0; i < num; i++)
		if(wp[i].SessionId == cons)
			if(ciwcscmp(wp[i].pProcessName, L"explorer.exe") == 0)
				break;
	if(i >= num)
		exits("unused");

	usrsz = nelem(usr);
	domsz= nelem(dom);
	if(LookupAccountSid(NULL, wp[i].pUserSid, usr, &usrsz, dom, &domsz, &type) == 0)
		sysfatal("unknown SID, intruder alert");
	WTSFreeMemory(wp);

	print("%w\n", usr);
	exits(nil);
}

