/* number of hyperthreads */
#include <u.h>
#include <libc.h>
#include <bio.h>
#include <mswin.h>

void
cpuid(int func, int idx, int *ax, int *bx, int *cx, int *dx)
{
	int a, b, c, d;

	 __asm__ __volatile__ (
		"cpuid":
			"=a" (a), "=b" (b), "=c" (c), "=d" (d) :
			"a" (func), "c" (idx)
	);

	*ax = a;
	*bx = b;
	*cx = c;
	*dx = d;
}

int
hype(void)
{
	int a, b, c, d;
	uint logical, cores;

	cpuid(1, 0, &a, &b, &c, &d);
	if(((d>>28)&1) == 0)
		return 1;
	logical = (b>>16)&0xff;

	cpuid(1, 0, &a, &b, &c, &d);
	if(a < 4)		/* leaf 4 not available */
		return 1;

	cpuid(4, 0, &a, &b, &c, &d);
	cores = ((a&0xfc000000)>>26)+1;

	return logical / cores;
	exits(nil);
}

void
main(int argc, char *argv[])
{
	print("%d\n", hype());
	exits(nil);
}

