/* contents of /dev/osversion on plan9 */
#include <u.h>
#include <libc.h>
#include <mswin.h>

static char *
winver(SYSTEM_INFO *si, OSVERSIONINFOEX *ver, int server2)
{
	int id, type;
	static char buf[32];

	id = ver->dwPlatformId;
	type = ver->wProductType;

	/*
	 * Note, some cases below are never exercised as
	 * GetVersionEx() is only supported from Win2k.
	 */
	switch((ver->dwMajorVersion << 8) | ver->dwMinorVersion){
	case 0x0400:
    	if(id == VER_PLATFORM_WIN32_WINDOWS)
			return "95";
    	if(id == VER_PLATFORM_WIN32_NT)
			return "NT 4.0";
		break;
	case 0x040a:
 		if(id == VER_PLATFORM_WIN32_WINDOWS)
			return "98";
		break;
	case 0x045a:
 		if(id == VER_PLATFORM_WIN32_WINDOWS)
			return "ME";
		break;
	case 0x0333:
		return "NT 3.51";
		break;
	case 0x0500:
		if(type == VER_NT_WORKSTATION)
			return "2000";
		else
			return "Server 2000";
		break;
	case 0x0501:
		return "XP";
		break;
	case 0x0502:
		if(type == VER_NT_WORKSTATION &&
		   si->dwProcessorType == PROCESSOR_ARCHITECTURE_AMD64)
				return "XP Pro x64";
		else
		if(server2)
			return "2003 r2";
		else
			return "2003";

		break;
	case 0x0600:
		if(type == VER_NT_WORKSTATION)
			return "Vista";
		else
			return "2008";
		break;
	case 0x0601:
		if(type == VER_NT_WORKSTATION)
			return "7";
		else
			return "2008 r2";
		break;
	case 0x0602:
		if(type == VER_NT_WORKSTATION)
			return "8";
		else
			return "2012";
		break;
	case 0x0603:
		if(type == VER_NT_WORKSTATION)
			return "8.1";
		else
			return "2012 r2";
		break;
	default:
		break;
	}
	if(type == VER_NT_WORKSTATION)
		snprint(buf, sizeof(buf), "v%ld.%ld workstation",
			ver->dwMajorVersion, ver->dwMinorVersion);
	else
		snprint(buf, sizeof(buf), "v%ld.%ld server",
			ver->dwMajorVersion, ver->dwMinorVersion);
	return buf;
}

void
main(int argc, char *argv[])
{
	int server2;
	SYSTEM_INFO si;
	OSVERSIONINFOEX ver;

	GetNativeSystemInfo(&si);
	ver.dwOSVersionInfoSize = sizeof(ver);
	GetVersionEx((OSVERSIONINFO *)&ver);
	server2 = GetSystemMetrics(SM_SERVERR2);

	print("Windows %s\n", winver(&si, &ver, server2));

	exits(nil);
}

