#include <u.h>
#include <libc.h>
#include <mswin.h>

void
main(int argc, char *argv[])
{
	SYSTEM_POWER_STATUS sps;

	if(GetSystemPowerStatus(&sps) == 0)
		sysfatal("%s: cannot get power status, %s\n", argv[0], _winerr());

	if(sps.BatteryFlag & 128){
		print("no battery\n");
		exits(nil);
	}

	if(sps.ACLineStatus == 0)
		print("discharge");
	else
	if(sps.BatteryFlag & 8)
		print("charge");
	else
		print("unknown");

	if(sps.BatteryLifePercent != 255)
		print(" %d%%", sps.BatteryLifePercent);

	if(sps.BatteryLifeTime != -1)
		print(" %d:%d:%d",
			sps.BatteryLifeTime/(60*60),
			(sps.BatteryLifeTime/60)%60,
			sps.BatteryLifeTime%60);

	print("\n");
}
