#include <u.h>
#include <libc.h>
#include <bio.h>
#include <ctype.h>

#include <mswin.h>

void
prname(Biobuf *bp, LUID *l, int enabled)
{
	DWORD len;
	int n;
	wchar_t *w, buf[1024];
	
	len = nelem(buf) - 1;
	LookupPrivilegeName(NULL, l, buf, &len);

	if(memcmp(buf, L"Se", sizeof(wchar_t)*2) == 0)
		w = buf+2;
	else
		w = buf;

	n = 0;
	while(*w){
		if(runestrcmp(w, L"Privilege") == 0)
			break;

		if(n != 0 && isupperrune(*w))
			n += Bprint(bp, " ");
		n += Bprint(bp, "%C", *w);
		w++;
	}
	if(enabled)
		Bprint(bp, "%*.s	enabled\n", 24-n, "");
	else
		Bprint(bp, "%*.s	disabled\n", 24-n, "");
}

void
main(int argc, char *argv[])
{
	int i;
	HANDLE h;
	DWORD len;
	TOKEN_PRIVILEGES *p;
	Biobuf bo;

	Binit(&bo, 1, OWRITE);
	quotefmtinstall();

	if(OpenProcessToken(GetCurrentProcess(), MAXIMUM_ALLOWED, &h) == 0)
		sysfatal("OpenProcessToken() failed, %s", _winerr());

	len = 0;
	GetTokenInformation(h, TokenPrivileges, NULL, 0, &len);
	if((p = malloc(len)) == nil)
		sysfatal("No memory, %r");
	if(GetTokenInformation(h, TokenPrivileges, p, len, &len) == 0)
		sysfatal("GetTokenInformation() failed, %s", _winerr());

	for(i = 0; i < p->PrivilegeCount; i++)
		prname(&bo, &p->Privileges[i].Luid, p->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED);
	exits(nil);
}
