#include <u.h>
#include <libc.h>
#include <win32.h>

#include <winbase.h>
#include <userenv.h>

wchar_t *
mkcmd(void)
{
	char *plan9, *cputype, *tmp;
	wchar_t *cmd;

	if((plan9 = getenv("plan9")) == nil)
		sysfatal("$plan9 not set in environment");
	if((cputype = getenv("cputype")) == nil)
		sysfatal("$cputype not set in environment");
	if((tmp = smprint("%s/%s/bin/rc", plan9, cputype)) == nil)
			sysfatal("No memory, %r");
	cmd = _winstr(tmp);
	free(tmp);
	free(cputype);
	free(plan9);
	return cmd;
}


void
usage(void)
{
	fprint(2, "usage: %s user[@domain] password cmd\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	DWORD sz;
	void *env;
	HANDLE tok;
	STARTUPINFO si;
	wchar_t prof[256];
	PROCESS_INFORMATION pi;
	wchar_t *user, *pass, *cmd;
	si.cb = sizeof(STARTUPINFO);

	ARGBEGIN{
	}ARGEND;

	if(argc != 3)
		usage();

	user = _winstr(argv[0]);
	cmd = mkcmd();

	pass = _winstr("pass");

	//
	// TO DO: change NULL to '.' to use local account database
	//
	if(LogonUser(user, NULL, pass, LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, &tok) == 0)
		sysfatal("LogonUser() failed, %s", _winerr());

	if(CreateEnvironmentBlock(&env, tok, TRUE) == 0)
		sysfatal("CreateEnvironmentBlock() failed, %s", _winerr());

	sz = nelem(prof);
	if(GetUserProfileDirectory(tok, prof, &sz) == 0)
		sysfatal("GetUserProfileDirectory() failed, %s", _winerr());

	//
	// TO DO: change NULL to '.' to use local account database
	//
	if(CreateProcessWithLogon(user, NULL, pass,
	  LOGON_WITH_PROFILE, NULL, cmd, CREATE_UNICODE_ENVIRONMENT, env, prof, &si, &pi) == 0)
		sysfatal("CreateProcessWithLogon() failed, %s", _winerr());

	if(DestroyEnvironmentBlock(env) == 0)
		sysfatal("DestroyEnvironmentBlock() failed, %s", _winerr());

	memset(pass, 0, _winlen(pass)*sizeof(wchar_t));
	CloseHandle(tok);

	WaitForSingleObject(pi.hProcess, INFINITE);

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);
	exits(nil);
}
