#include <u.h>
#include <libc.h>
#include <win32.h>

void
grantaccess(void)
{
	SECURITY_DESCRIPTOR *sd;
	HWINSTA hws;
	HDESK hdesk;
	SECURITY_INFORMATION si;
	int buff[SECURITY_DESCRIPTOR_MIN_LENGTH];
	sd = (SECURITY_DESCRIPTOR *)buff;

	if(InitializeSecurityDescriptor(sd, SECURITY_DESCRIPTOR_REVISION) == 0)
		sysfatal("InitializeSecurityDescriptor() failed, %s", _winerr());
	if(SetSecurityDescriptorDacl(sd, 1, nil, FALSE) == 0)
		sysfatal("SetSecurityDescriptorDacl() failed, %s", _winerr());
		
	if ((hws = GetProcessWindowStation()) == 0)
		sysfatal("GetProcessWindowStation() failed, %s", _winerr());
	si = DACL_SECURITY_INFORMATION;
	SetUserObjectSecurity(hws, &si, sd);
	CloseHandle(hws);

	if((hdesk = GetThreadDesktop(GetCurrentThreadId())) != 0){
		si = DACL_SECURITY_INFORMATION;
		SetUserObjectSecurity(hdesk, &si, sd);
		CloseHandle(hdesk);
	}

	si = DACL_SECURITY_INFORMATION;
	SetUserObjectSecurity(GetStdHandle(STD_INPUT_HANDLE), &si, sd);
	si = DACL_SECURITY_INFORMATION;
	SetUserObjectSecurity(GetStdHandle(STD_OUTPUT_HANDLE), &si, sd);
	si = DACL_SECURITY_INFORMATION;
	SetUserObjectSecurity(GetStdHandle(STD_ERROR_HANDLE), &si, sd);
}

void
usage(void)
{
	fprint(2, "usage: %s user pass cmd\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	HANDLE tok;
	STARTUPINFO si = { 0 };
	PROCESS_INFORMATION pi;
	TOKEN_PRIVILEGES *tkp, *buf;
	wchar_t *user, *pass, *cmd;

	ARGBEGIN{
	}ARGEND;

	if(argc != 3)
		usage();

	if((buf = malloc(1024)) == nil)
		sysfatal("No memory, %r");
	tkp = buf;

	user = _winstr(argv[0]);
	pass = _winstr(argv[1]);
	if(LogonUser(user, nil, pass ,LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, &tok) == 0)
		sysfatal("LogonUser() failed, %s", _winerr());

	LookupPrivilegeValue(nil, SE_TCB_NAME, &tkp->Privileges[0].Luid); 
	tkp->Privileges[0].Attributes = SE_PRIVILEGE_ENABLED; 
	
	LookupPrivilegeValue(nil, SE_ASSIGNPRIMARYTOKEN_NAME, &tkp->Privileges[1].Luid); 
	tkp->Privileges[1].Attributes = SE_PRIVILEGE_ENABLED; 
	
	LookupPrivilegeValue(nil, SE_INCREASE_QUOTA_NAME, &tkp->Privileges[2].Luid); 
	tkp->Privileges[2].Attributes = SE_PRIVILEGE_ENABLED; 
	
	tkp->PrivilegeCount = 3;

	if(AdjustTokenPrivileges(tok, FALSE, tkp, 0, (PTOKEN_PRIVILEGES)nil, 0) == 0)
		sysfatal("AdjustTokenPrivileges() failed, %s", _winerr());

	grantaccess();
//		si.lpDesktop = L"winsta0\\default";

	si.cb = sizeof(STARTUPINFO);
	cmd = _winstr(argv[2]);
	if(CreateProcessAsUser(tok, cmd, nil, nil, nil, 1, 0, nil, nil, &si, &pi) == 0)
		sysfatal("CreateProcessAsUser() failed, %s", _winerr());

	if(WaitForSingleObject(pi.hProcess, INFINITE) == 0)
		sysfatal("WaitForSingleObject() failed, %s", _winerr());
	exits(nil);
}
