#include <u.h>
#include <libc.h>
/*
 * Print working (current) directory
 */

static void
usage(void)
{
	fprint(2, "usage: %s [-9]\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	int nine;
	char *sys, cwd[8192];

	nine = 0;
	ARGBEGIN{
	case '9':		/* remote path, for plan9's plumber */
		nine++;
		break;
	default:
		usage();
		break;
	}ARGEND;


	if(getwd(cwd, sizeof(cwd)) == 0){
		fprint(2, "pwd: %r\n");
		exits("getwd");
	}

	*cwd = tolower(*cwd);
	if(nine && strlen(cwd) >= 2 && cwd[1] == ':'){
		if((sys = sysname()) == nil)
			sysfatal("sysname() failed, %r");

		print("/n/%s/%c%s\n", sys, *cwd, cwd+2);
	}
	else{
		print("%s\n", cwd);
	}

	exits(0);
}
