#include <u.h>
#include <libc.h>

#include <mswin.h>
#include <wincrypt.h>

ulong
truerand(void)
{
	ulong x;
	static int first = 1;
	static HCRYPTPROV h;

	if(first){
		if(CryptAcquireContext(&h, nil, nil, PROV_RSA_FULL,  CRYPT_VERIFYCONTEXT|CRYPT_SILENT) == 0){
			werrstr("%s", _winerr());
			return (ulong)-1;
		}
		first = 0;
	}

	if(CryptGenRandom(h, sizeof(x), (BYTE *)&x) == 0){
		werrstr("%s", _winerr());
		return (ulong)-1;
	}
	return x;
}
