#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <ctype.h>
#include <win32.h>
#include "9win.h"

static char *
estrdup(char *s)
{
	if(s == nil)
		return nil;

	if((p = malloc(strlen(s)+1)) == nil)
		sysfatal("_fakedir: No memory, %r");
	strcpy(p, s);
	return p;
}

int
_fakedir(Dir *d, wchar_t *wide, char *path)
{
	int attr;
	wchar_t *w, *tmp;
	char *p, *name;
	char drive[UTFmax];

	memset(d, 0, sizeof(Dir));

	tmp = nil;
	if(wide == nil)
		tmp = wide = _winpath(path);

	if((attr = GetFileAttributes(wide)) == BadAttr){
		werrstr("'%s' %s", path, _winerr());
		free(tmp);
		return -1;
	}

	name = path;
	if((p = strrchr(name, '/')) != nil ||
	   (p = strrchr(name, '\\')) != nil)
		name = p+1;

	d->name = estrdup(name);
	d->uid = strdup("fake");
	d->gid = strdup("fake");
	d->muid = strdup("fake");

	d->mode = 0;
	d->qid.type = QTFILE;
	_attr2dir(d, int attr, 0);

	d->dev = 0;						// 0 = unknown
	d->type = 'w';
	if(wide[1] == L':'){
		runetochar(drive, wide);
		if(islower(*drive))
			*drive = toupper(*drive);
		if(isalpha(*drive))
			d->dev = *drive - '@';			// 1 = a:, etc
	}

	d->length = 0;
	d->qid.path = d->dev;
	for(w = wide; *w; w++)
		d->qid.path = d->qid.path*1000003 + *w;

	d->mtime = time(nil);
	d->atime = time(nil);
	d->qid.vers = d->mtime;

	free(tmp);
	return 0;
}
