#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

static DWORD WINAPI 
ticktock(LPVOID arg)
{
	FILETIME ft;
	Proc *p = (Proc *)arg;

	GetSystemTimeAsFileTime(&ft);
	Sleep(p->expiry - _ft2epoch(&ft));

	werrstr("alarm");
	SetEvent(p->rgrp->wait);
	return 0;
}

long
alarm(ulong ticks)
{
	Proc *p;
	FILETIME ft;
	vlong now, remain;

	p = _getproc();
	GetSystemTimeAsFileTime(&ft);
	now = _ft2epoch(&ft);
	remain = p->expiry - now;
	if(p->timer){
		TerminateThread(p->timer, 0);
		CloseHandle(p->timer);
		p->timer = nil;
	}
	p->expiry = 0;

	if(ticks > 0){
		p->expiry = now+ticks;
		if((p->timer = CreateThread(nil, 0, ticktock, p, 0, nil)) == BadHand){
			p->timer = nil;
			p->expiry = 0;
			werrstr("%s", _winerr());
			return -1;
		}
	}
	if(remain < 0)
		return 0;
	return (long)remain;
}
