#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "error.h"
#include "9win.h"

int
close(int fd)
{
	File *f;
	Fgrp *fg;
	int rc, type;
	HANDLE hand;

	rc = 0;
	fg = _getproc()->fgrp;
	qlock(fg);

	if((f = _lookfile(fg, fd)) == nil){
		qunlock(fg);
		return -1;
	}
	hand = f->hand;
	type = f->type;
	if(_freefile(fg, fd) < 0)
		rc = -1;

	switch(type){
	case Tdir:
		if(FindClose(hand) == 0){
			werrstr("%s", _winerr());
			rc = -1;
		}
		break;
	case Tfile:
		if(CloseHandle(hand) == 0){
			werrstr("%s", _winerr());
			rc = -1;
		}
		break;
	case Ttcp:
	case Tudp:
		if(_skt_close((int)hand) != 0)
			rc = -1;
		break;
	case Tinvalid:
		werrstr("0x%p, bad handle", f->hand);
		rc = -1;
	default:
		werrstr(Ebadusefd);
		rc = -1;
	}

	qunlock(fg);
	return rc;
}
