#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

int
dup(int src, int dst)
{
	int fd;
	File *f;
	Fgrp *fg;
	HANDLE newhand;

	if(src == dst)
		_debug("dup() src==dst==%d\n", src);

	fg = _getproc()->fgrp;
	qlock(fg);
	if ((f = _lookfile(fg, src)) == nil){
		qunlock(fg);
		return -1;
	}
	qlock(f);
	qunlock(fg);

	if((DuplicateHandle(GetCurrentProcess(), f->hand,
						GetCurrentProcess(),  &newhand,
		0, FALSE, DUPLICATE_SAME_ACCESS)) == 0){
		werrstr("%s", _winerr());
		qunlock(fg);
		return -1;
	}

	if(dst != -1)
		close(dst);

	qlock(fg);
	qunlock(f);
	if((fd = _allocfile(fg, newhand, f->type, f->omode, f->path, dst)) == -1){
		CloseHandle(newhand);
		qunlock(fg);
		return -1;
	}
	qunlock(fg);
	return 0;
}

