#include <u.h>
#include <libc.h>
#include <mswin.h>

#include "9win.h"

static Note Notes[] = {
	{ ConsExceptBase+CTRL_C_EVENT,			Ncons,		"interrupt" },
	{ ConsExceptBase+CTRL_BREAK_EVENT,		Ncons,		"quit" },
	{ ConsExceptBase+CTRL_CLOSE_EVENT,		Ncons,		"close" },
	{ ConsExceptBase+CTRL_LOGOFF_EVENT,		Ncons,		"hangup" },
	{ ConsExceptBase+CTRL_SHUTDOWN_EVENT,	Ncons,		"shutdown" },

	{ FAKE_ALARM_CALL,						Nexcept,	"alarm" },
	{ FAKE_KILL_PROCESS,					Nterm,		"kill" },
	{ FAKE_LOAD_FAIL,						Nexcept,	"sys: exec: load fail - missing DLL?" },
	{ FAKE_BROKEN_PIPE_WRITE,				Nexcept,	"sys: write on closed pipe" },

	{ EXCEPTION_ACCESS_VIOLATION,			Nexcept,	"sys: illegal address" },
	{ EXCEPTION_DATATYPE_MISALIGNMENT,		Nexcept,	"sys: odd address" },
	{ EXCEPTION_STACK_OVERFLOW,				Nexcept,	"sys: stack overflow" },
	{ EXCEPTION_BREAKPOINT,					Nexcept,	"sys: breakpoint" },
	{ EXCEPTION_SINGLE_STEP,				Nexcept,	"sys: single step" },

	{ EXCEPTION_FLT_DENORMAL_OPERAND,		Nexcept,	"sys: fp denormal operand" },
	{ EXCEPTION_FLT_DIVIDE_BY_ZERO,			Nexcept,	"sys: fp divide by zero" },
	{ EXCEPTION_FLT_INEXACT_RESULT,			Nexcept,	"sys: fp inexact result" },
	{ EXCEPTION_FLT_INVALID_OPERATION,		Nexcept,	"sys: fp invalid operation" },
	{ EXCEPTION_FLT_OVERFLOW,				Nexcept,	"sys: fp overflow" },
	{ EXCEPTION_FLT_STACK_CHECK,			Nexcept,	"sys: fp stack check" },
	{ EXCEPTION_FLT_UNDERFLOW,				Nexcept,	"sys: fp underflow" },

	{ EXCEPTION_ARRAY_BOUNDS_EXCEEDED,		Nexcept,	"sys: trap: array bounds" },
	{ EXCEPTION_INT_DIVIDE_BY_ZERO,			Nexcept,	"sys: trap: int divide by zero" },
	{ EXCEPTION_INT_OVERFLOW,				Nexcept,	"sys: trap: int overflow" },
	{ EXCEPTION_PRIV_INSTRUCTION,			Nexcept,	"sys: trap: privileged instruction" },
	{ EXCEPTION_IN_PAGE_ERROR,				Nexcept,	"sys: trap: page-in error" },
	{ EXCEPTION_ILLEGAL_INSTRUCTION,		Nexcept,	"sys: trap: illegal instruction" },
	{ EXCEPTION_NONCONTINUABLE_EXCEPTION,	Nexcept,	"sys: trap: non-continuable exception" },
	{ EXCEPTION_INVALID_DISPOSITION,		Nexcept,	"sys: trap: invalid disposition" },
	{ EXCEPTION_GUARD_PAGE,					Nexcept,	"sys: trap: guard page" },
	{ EXCEPTION_INVALID_HANDLE,				Nexcept,	"sys: trap: invalid handle" },
};

Note *
_code2note(int code)
{
	int i;

	for(i = 0; i < nelem(Notes); i++)
		if(Notes[i].code == code)
			return &Notes[i];
	return nil;
}

Note *
_name2note(char *name)
{
	int i;

	for(i = 0; i < nelem(Notes); i++)
		if(strcmp(Notes[i].name, name) == 0)
			return &Notes[i];
	return nil;
}
