#include <u.h>
#include <libc.h>
#include "error.h"
#include <mswin.h>
#include "9win.h"

char *
_reslash(char *str)
{
	char *p, *l;

	str = strdup(str);
	if(str == nil)
		sysfatal("_reslash: No memory, %r");

	l = nil;
	for(p = str; *p; p++){
		if(*p == '\\')
			*p = '/';
		if(*p == '/')
			l = p;
	}

	/*
	 * has a slash,
	 * not the first letter (root dir),
	 * is last char,
	 * then clear it
	 */
	if(l != nil && l != str && l[1] == 0)
		*l = 0;

	return str;
}

int
_allocfile(HANDLE h, int type, int omode, char *path, int fd)
{
	File *f;
	Proc *p;

	p = _getproc();
	if(fd != -1 && fd < nelem(p->files)){
		f = &p->files[fd];
		if(f->h != nil){
			werrstr(Ebadusefd);
			return -1;
		}
	}
	else{
		for(f = p->files; f < &p->files[nelem(p->files)]; f++)
			if(f->h == nil)
				break;
		if(f >= &p->files[nelem(p->files)]){
			werrstr(Enofd);
			return -1;
		}
	}
	f->h = h;
	f->type = type;
	f->omode = omode;
	f->path = _reslash(path);
	if(f->path == nil)
		_panic("newfile: no memory for strdup\n");
	f->off = 0;
	f->slot = 0;
	return f - p->files;
}

File *
_lookfile(int fd)
{
	Proc *p;

	p = _getproc();
	if(fd < 0 || fd > nelem(p->files) || p->files[fd].h == nil){
		werrstr(Enofd);
		return nil;
	}
	return &p->files[fd];
}


int
_newfgrp(Proc *new)
{
	int i;
	Proc *old;

	old = _getproc();
	for(i = 0; i < nelem(old->files); i++){
		new->files[i] = old->files[i];
		if(new->files[i]){
			new->path = strdup(old->path);
			if(new->path == nil)
				return -1;
			if((DuplicateHandle(GetCurrentProcess(), old->h, GetCurrentProcess(), 
				&new->h, 0, FALSE, DUPLICATE_SAME_ACCESS)) == 0)
				return -1;
		}
	}
	return 0;
}

int
_freefile(int fd)
{
	File *f;
	Proc *p;

	p = _getproc();
	if(fd < 0 || fd > nelem(p->files) || p->files[fd].h == nil){
		werrstr(Enofd);
		return -1;
	}
	f = &p->files[fd];
	free(f->path);
	CloseHandle(f->h);
	f->h = nil;
	return 0;
}
