#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <mswin.h>
#include "9win.h"

int
fwstat(int fd, uchar *edir, int nedir)
{
	Dir d;
	File *f;
	Fgrp *fg;
	char *strs;
	int rc, len;

	fg = _getproc()->fgrp;
	qlock(fg);
	if ((f = _lookfile(fg, fd)) == nil){
		qunlock(fg);
		return -1;
	}
	qlock(f);
	qunlock(fg);

	if((len = convM2D(edir, nedir, &d, nil)) == 0){
		qunlock(f);
		return -1;
	}
	if((strs = malloc(len)) == nil){
		qunlock(f);
		return -1;
	}
	if(convM2D(edir, nedir, &d, strs) == 0){
		free(strs);
		qunlock(f);
		return -1;
	}
	rc = _dowstat(f->path, &d);
	FlushFileBuffers(f->hand);		// ignore errors - best effort only
	free(strs);
	qunlock(f);
	return rc;
}
