#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

int
open(char *path, int mode)
{
	int fd;
	Fgrp *fg;
	HANDLE h;
	wchar_t *tmp;
	int access, flags, share, disp, attr, type;

	h = BadHand;
	fg = _getproc()->fgrp;

	tmp = _winstr(path);			/* FIXME: necessary to allow device files to work */
//	tmp = _winpath(path);
	_fixpath(tmp);
	if((attr = GetFileAttributes(tmp)) == -1){
		werrstr("'%s' %s", path, _winerr());
		free(tmp);
		return -1;
	}

	flags = 0;
	type = Tfile;
	share = FILE_SHARE_WRITE|FILE_SHARE_READ|FILE_SHARE_DELETE;
	if(attr & FILE_ATTRIBUTE_DIRECTORY){
		if(mode != OREAD){
			werrstr("invalid mode");
			free(tmp);
			return -1;
		}
		free(tmp);
		qlock(fg);
		fd = _allocfile(fg, BadHand, Tdir, mode, path, -1);
		qunlock(fg);
		return fd;
	}

	switch(mode&3){
	default:
		access = 0;
		break;
	case OREAD:
		access = GENERIC_READ;
		break;
	case OWRITE:
		access = GENERIC_WRITE;
		break;
	case ORDWR:
		access = GENERIC_READ|GENERIC_WRITE;
		break;
	case OEXEC:
		access = GENERIC_EXECUTE;
		break;
	}

	disp = OPEN_EXISTING;
	if(mode&OTRUNC)
		disp = TRUNCATE_EXISTING;
	if(mode&ORCLOSE)
		flags |= FILE_FLAG_DELETE_ON_CLOSE;
	if(mode&OEXCL)
		share = 0;

	if((h = CreateFile(tmp, access, share, nil, disp, flags, nil)) == BadHand){
		werrstr("'%s' %s", path, _winerr());
		free(tmp);
		return -1;
	}

	free(tmp);
	qlock(fg);
	fd = _allocfile(fg, h, type, mode, path, -1);
	if(fd == -1)
		CloseHandle(h);
	qunlock(fg);
	return fd;
}
