#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

enum {
	Npipe = 8192,		// big enough for a 9p message
};

static int seq;

int
pipe(int fd[2])
{
	Fgrp *fg;
	wchar_t *win;
	HANDLE h0, h1;
	char name[128];

	seq++;
	snprint(name, sizeof(name), "\\\\.\\pipe\\9win.%d.%d", GetCurrentProcessId(), seq);
	win = _winpath(name);

	if((h0 = CreateNamedPipe(win, PIPE_ACCESS_DUPLEX,
		PIPE_TYPE_MESSAGE|PIPE_READMODE_BYTE,
		PIPE_UNLIMITED_INSTANCES, Npipe, Npipe, 0, NULL)) == INVALID_HANDLE_VALUE){
		werrstr("%s cannot create pipe, %s", win, _winerr());
		free(win);
		return -1;
	}

	if((h1 = CreateFile(win, GENERIC_WRITE|GENERIC_READ, 0,
	  NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE){
		werrstr("%s cannot open pipe, %s", win, _winerr());
		CloseHandle(h0);
		free(win);
		return -1;
	}

	fg = _getproc()->fgrp;
	qlock(fg);
	if((fd[0] = _allocfile(fg, h0, Tpipe, OREAD, name, -1)) == -1){
		qunlock(fg);
		CloseHandle(h0);
		CloseHandle(h1);
		free(win);
		return -1;
	}

	if((fd[1] = _allocfile(fg, h1, Tpipe, OWRITE, name, -1)) == -1){
		qunlock(fg);
		CloseHandle(h0);
		CloseHandle(h1);
		_freefile(fg, fd[0]);
		free(win);
		return -1;
	}
	qunlock(fg);
	free(win);
	return 0;
}
