#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <mswin.h>
#include "9win.h"

static int
isdots(wchar_t *r)
{
	if(_wincmp(r, L".") == 0)
		return 1;
	if(_wincmp(r, L"..") == 0)
		return 1;
	return 0;
}

static int
direrr(File *f)
{
	switch(GetLastError()){
	case ERROR_NO_MORE_FILES:
		SetLastError(0);
		return 0;
	default:
		werrstr("'%s' %s", f->path, _winerr());
		return -1;
	}
}

int
_readdir(File *f, void *edir, int nedir)
{
	Dir d;
	int n, rc;
	wchar_t *tmp;
	WIN32_FIND_DATA fd;

	memset(&d, 0, sizeof(d));
	if(f->slot == 0){
		if(f->hand != BadHand)
			FindClose(f->hand);
		tmp = _winpath2(f->path, L"*");
		if((f->hand = FindFirstFile(tmp, &fd)) == BadHand){
			free(tmp);
			rc = direrr(f);
			return rc;
		}
		free(tmp);
		while(isdots(fd.cFileName)){
			if(FindNextFile(f->hand, &fd) == 0){
				rc = direrr(f);
				return rc;
			}
		}
	}
	else{
		do{
			if(FindNextFile(f->hand, &fd) == 0){
				rc = direrr(f);
				return rc;
			}
		}while(isdots(fd.cFileName));

	}
	_find2dir(f->path, nil, &fd, &d);
	n = convD2M(&d, edir, nedir);
	free(d.name);
	free(d.uid);
	free(d.gid);
	free(d.muid);
	f->slot++;
	return n;
}


