#include <u.h>
#include <libc.h>
#include <mswin.h>
#include "9win.h"

int
remove(char *path)
{
	wchar_t *tmp;
	int rc, a;

	tmp = _winpath(path);
	if((a = _checkcase(tmp)) == -1){
		werrstr("%s", _winerr());
		free(tmp);
		return -1;
	}
	if(a & FILE_ATTRIBUTE_READONLY)
		SetFileAttributes(tmp, a & ~FILE_ATTRIBUTE_READONLY);

	rc = 0;
	if(a & FILE_ATTRIBUTE_DIRECTORY){
		if(RemoveDirectory(tmp) == 0){
			werrstr("%s", _winerr());
			rc = -1;
		}
	}
	else{
		if(DeleteFile(tmp) == 0){
			werrstr("%s", _winerr());
			rc = -1;
		}
	}
	if(rc == -1)
		SetFileAttributes(tmp, a);
	free(tmp);
	return rc;
}
