#include <u.h>
#include <libc.h>
#include "error.h"
#include <mswin.h>
#include "9win.h"

vlong
seek(int fd, vlong off, int w)
{
	File *f;
	Fgrp *fg;
	DWORD lo, hi;

	fg = _getproc()->fgrp;
	qlock(fg);
	if ((f = _lookfile(fg, fd)) == nil){
		qunlock(fg);
		return -1L;
	}
	qlock(f);
	qunlock(fg);

	switch(f->type){
	case Tfile:
		break;
	case Ttcp:
	case Tudp:
	case Tdev:
	case Tpipe:
	case Tcons:
		werrstr(Eisstream);
		qunlock(f);
		return -1;
		break;
	case Tdir:
		werrstr(Edirseek);
		qunlock(f);
		return -1;
		break;
	case Tinvalid:
		werrstr("%p bad handle", f->hand);
		qunlock(f);
		return -1;
	default:
		werrstr(Ebadusefd);
		qunlock(f);
		return -1;
		break;
	}

	switch(w){
	case 0:
		f->off = off;
		break;
	case 1:
		f->off += off;
		break;
	case 2:
		if((lo = GetFileSize(f->hand, &hi)) == INVALID_FILE_SIZE){
			werrstr("'%s' cannot get file size", f->path);
			qunlock(f);
			return -1L;
		}
		f->off = (((vlong)hi >> 32 ) | lo) + off;
		break;
	default:
		werrstr(Ebadarg);
		qunlock(f);
		return -1L;
	}
	qunlock(f);
	return f->off;
}
