#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <tlhelp32.h>

int
GetParentProcessId(void)
{
	int rc;
	HANDLE hs;
	ulong pid, ppid;
	PROCESSENTRY32 pe;

	pid = GetCurrentProcessId();
	if((hs = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)) == INVALID_HANDLE_VALUE){
		werrstr(_winerr());
		return -1;
	}

	ppid = -1;					/* can never fail, this just keeps gcc happy */
	pe.dwSize = sizeof(pe);
	rc = Process32First(hs, &pe);
	while(rc){
		if(pe.th32ProcessID == pid){
			ppid = pe.th32ParentProcessID;
			break;
		}
		rc = Process32Next(hs, &pe);
	}
	CloseHandle(hs);
	return ppid;
}
