#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winbase.h>
#include <winioctl.h>

char *
_linktarg(char *path)
{
	DWORD got;
	HANDLE h;
	wchar_t *tmp;
	char buf[4096];
	REPARSE_DATA_BUFFER *rdb;

	tmp = _winpath(path);
	if((h = CreateFile(tmp, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
			FILE_FLAG_OPEN_REPARSE_POINT|FILE_FLAG_BACKUP_SEMANTICS, nil)) == BadHand){
		werrstr("%s", _winerr());
		free(tmp);
		return nil;
	}
	free(tmp);

	if(DeviceIoControl(h, FSCTL_GET_REPARSE_POINT, nil, 0, buf, sizeof(buf), &got, nil) == 0){
		werrstr("%s", _winerr());
		CloseHandle(h);
		return nil;
	}
	CloseHandle(h);

	rdb = (REPARSE_DATA_BUFFER *)buf;
	if(rdb->ReparseTag != IO_REPARSE_TAG_MOUNT_POINT && rdb->ReparseTag != IO_REPARSE_TAG_SYMLINK)
		return nil;

	rdb->SymbolicLinkReparseBuffer.PathBuffer[rdb->SymbolicLinkReparseBuffer.PrintNameLength / sizeof(wchar_t)] = 0;
	return _ninepath(rdb->SymbolicLinkReparseBuffer.PathBuffer);
}

/*

char *
_linktarg(char *path)
{
	HANDLE h;
	wchar_t *tmp;
	char mem[4096];
	FILE_NAME_INFO *fn = (FILE_NAME_INFO *)mem;

	tmp = _winpath(path);
	if((h = CreateFile(tmp, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, nil)) == BadHand){
		werrstr("%s", _winerr());
		free(tmp);
		return nil;
	}
	free(tmp);

	if(GetFileInformationByHandleEx(h, FileNameInfo, mem, sizeof(mem)) == 0){
		werrstr("%s", _winerr());
		CloseHandle(h);
		return nil;
	}
	CloseHandle(h);

	return _ninepath(fn->FileName);
	return 0;
}

*/
