#include <u.h>
#include <libc.h>
#include <mswin.h>

/*
 * This is expensive and only works on NTFS
 * so this check is only done on the error path.
 */
int
_samefile(wchar_t *src, wchar_t *dst)
{
	HANDLE h;
	BY_HANDLE_FILE_INFORMATION si, di;

	if((h = CreateFile(src, GENERIC_WRITE, 0, nil, OPEN_EXISTING, 0, nil)) == BadHand)
		return 0;
	if(GetFileInformationByHandle(h, &si) == 0){
		CloseHandle(h);
		return 0;
	}
	CloseHandle(h);

	if((h = CreateFile(dst, GENERIC_WRITE, 0, nil, OPEN_EXISTING, 0, nil)) == BadHand)
		return 0;
	if(GetFileInformationByHandle(h, &di) == 0){
		CloseHandle(h);
		return 0;
	}
	CloseHandle(h);

	if(si.dwVolumeSerialNumber != di.dwVolumeSerialNumber)
		return 0;
	if(si.nFileIndexHigh != di.nFileIndexHigh)
		return 0;
	if(si.nFileIndexLow != di.nFileIndexLow)
		return 0;
	return 1;
}
