#include <u.h>
#include <libc.h>
#include <mswin.h>
#include <Lm.h>
#include <Lmwksta.h>

/* take privilege(s) in the current process if our account allows it */
int
_takepriv(wchar_t *name)
{
	HANDLE h;
	LUID luid;
	TOKEN_PRIVILEGES priv;

	SetLastError(0);
	if(OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &h) == 0 || GetLastError() != 0){
		werrstr("OpenProcessToken %s", _winerr());
		return -1;
	}

	SetLastError(0);
	if(LookupPrivilegeValue(L"", name, &luid) == 0 || GetLastError() != 0){
		werrstr("LookupPrivilegeValue %s", _winerr());
		CloseHandle(h);
		return -1;
	}

	SetLastError(0);
	priv.PrivilegeCount = 1;
	priv.Privileges[0].Luid = luid;
	priv.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	if(AdjustTokenPrivileges(h, FALSE, &priv, sizeof(priv), nil, nil) == 0 || GetLastError() != 0){
		werrstr("AdjustTokenPrivileges %s", _winerr());
		CloseHandle(h);
		return -1;
	}
	CloseHandle(h);
	return 0;
}

