#include <u.h>
#include <libc.h>
#include <mswin.h>

extern int _quotestrfmt(int runesin, Fmt *f, void *); 	/* see /sys/src/libc/fmt/quotefmt.c */

static int
wcfmt(Fmt *f)
{
	int n;
	Rune *rune, *r;
	wchar_t *wide, *w;

	wide = va_arg(f->args, wchar_t *);
	if(wide == nil)
		return fmtprint(f,	"<nil>");

	n = 0;
	w = wide;
	while(*w){
		n++;
		w++;
	}
	n++;

	rune = malloc(n*sizeof(Rune));
	if(rune == nil)
		return fmtprint(f,	"<no memory %d>", n*sizeof(Rune));

	w = wide;
	r = rune;
	while(*w)
		*r++ = *w++;
	*r = 0;

	switch(f->r){
	case 'W':
		n = _quotestrfmt(1, f, rune);
		break;
	case 'w':
		n = fmtrunestrcpy(f, rune);
		break;
	default:
		n = fmtprint(f,	"<%%%c - bad wide format>", f->r);
		break;
	}
	free(rune);
	return n;
}

int
_widefmtinstall(void)
{
	if(fmtinstall('w', wcfmt) < 0)
		return -1;
	if(fmtinstall('W', wcfmt) < 0)
		return -1;
	return 0;
}
