#include <u.h>
#include <libc.h>
#include <mswin.h>

#include <winsock2.h>
#include <ws2tcpip.h>

extern void _cleanerr(char *str);

char * 
_skt_errstr(void)
{
	char *str;
	int e, flags;
	wchar_t msg[ERRMAX];
	static char buf[ERRMAX];
	static int WINAPI (*get)(void);
	static int WINAPI (*set)(int err);

	if(! get)
		get = _latebind(WINSOCK2_DLL, "WSAGetLastError");
	if(! set)
		set = _latebind(WINSOCK2_DLL, "WSASetLastError");

	e = get();
	set(0);

	*buf = 0;
	if(e == 0)
		return buf;

	flags = FORMAT_MESSAGE_MAX_WIDTH_MASK | FORMAT_MESSAGE_FROM_SYSTEM;
	if(FormatMessage(flags, nil, e, 0, msg, nelem(msg), nil) == 0){
		snprint(buf, sizeof(buf), "%d - unknown winsock error", e);
		return buf;
	}

	str = _ninestr(msg);
	_cleanerr(str);
	snprint(buf, sizeof(buf), "%s (0x%ux)", str, e);
	free(str);
	return buf;
}
