
#include <winsta.h>

#define WTS_CURRENT_SERVER_HANDLE 0

typedef struct _WTS_PROCESS_INFO {
	DWORD SessionId;
	DWORD ProcessId;
	LPTSTR pProcessName;
	PSID pUserSid;
} WTS_PROCESS_INFO, *PWTS_PROCESS_INFO;

extern BOOL WINAPI WTSEnumerateProcesses(HANDLE, DWORD, DWORD, PWTS_PROCESS_INFO *, DWORD *);

typedef struct _WTS_CLIENT_ADDRESS {
  DWORD AddressFamily;
  BYTE  Address[20];
} WTS_CLIENT_ADDRESS, *PWTS_CLIENT_ADDRESS ;

typedef struct _WTSINFO {
  WTS_CONNECTSTATE_CLASS State;
  DWORD                  SessionId;
  DWORD                  IncomingBytes;
  DWORD                  OutgoingBytes;
  DWORD                  IncomingFrames;
  DWORD                  OutgoingFrames;
  DWORD                  IncomingCompressedBytes;
  DWORD                  OutgoingCompressedBytes;
  WCHAR                  WinStationName[WINSTATIONNAME_LENGTH];
  WCHAR                  Domain[DOMAIN_LENGTH];
  WCHAR                  UserName[USERNAME_LENGTH+1];
  LARGE_INTEGER          ConnectTime;
  LARGE_INTEGER          DisconnectTime;
  LARGE_INTEGER          LastInputTime;
  LARGE_INTEGER          LogonTime;
  LARGE_INTEGER          CurrentTime;
} WTSINFO, *PWTSINFO;

typedef struct _WTSCLIENT {
  WCHAR   ClientName[CLIENTNAME_LENGTH + 1];
  WCHAR   Domain[DOMAIN_LENGTH + 1 ];
  WCHAR   UserName[USERNAME_LENGTH + 1];
  WCHAR   WorkDirectory[MAX_PATH + 1];
  WCHAR   InitialProgram[MAX_PATH + 1];
  BYTE    EncryptionLevel;
  ULONG   ClientAddressFamily;
  USHORT  ClientAddress[CLIENTADDRESS_LENGTH + 1];
  USHORT  HRes;
  USHORT  VRes;
  USHORT  ColorDepth;
  WCHAR   ClientDirectory[MAX_PATH + 1];
  ULONG   ClientBuildNumber;
  ULONG   ClientHardwareId;
  USHORT  ClientProductId;
  USHORT  OutBufCountHost;
  USHORT  OutBufCountClient;
  USHORT  OutBufLength;
  WCHAR     DeviceId[MAX_PATH + 1];
} WTSCLIENT, *PWTSCLIENT;

HANDLE WTSOpenServer(LPTSTR pServerName);
VOID WINAPI WTSCloseServer(HANDLE hServer);

typedef struct _WTS_SERVER_INFO {
  LPTSTR pServerName;
} WTS_SERVER_INFO, *PWTS_SERVER_INFO;

BOOL WINAPI WTSEnumerateServers(LPTSTR pDomainName, DWORD Reserved, DWORD Version, PWTS_SERVER_INFO *ppServerInfo, DWORD *pCount);